/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2020 All Rights Reserved.
 */

package com.abssqr.plat.biz.api.ast;

import com.abssqr.plat.biz.support.ServiceSupport;
import com.abssqr.plat.common.dal.mysql.auto.paging.AstPackPagePage;
import com.abssqr.plat.common.dal.mysql.auto.resultmap.AstPackItem;
import com.abssqr.plat.common.facade.param.ast.AstPackOprParam;
import com.abssqr.plat.common.facade.param.ast.AstPackQryParam;
import com.abssqr.plat.common.facade.result.BasePage;
import com.abssqr.plat.common.facade.result.pack.AstPackListVO;
import com.abssqr.plat.common.facade.service.ast.AstPackService;
import com.abssqr.plat.common.facade.validation.Valid;
import com.abssqr.plat.common.model.convertor.LoanConvert;
import com.abssqr.plat.common.model.convertor.vo.AstPackListVOConvert;
import com.abssqr.plat.common.model.domain.ast.AstPack;
import com.abssqr.plat.common.model.exception.AbssqrBizException;
import com.abssqr.plat.common.model.repo.ast.AstPackRepo;
import com.abssqr.plat.core.service.ast.AstPackManager;
import com.general.system.common.util.VarChecker;
import com.google.common.collect.Lists;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author xiachenxiang
 * @version com.abssqr.plat.biz.api.ast: AstPackServiceImpl.java, v 0.1 2020-04-18 3:13 PM xiachenxiang Exp $
 */
@Service
public class AstPackServiceImpl extends ServiceSupport implements AstPackService {
    @Autowired
    private AstPackManager astPackManager;
    @Autowired
    private AstPackRepo    astPackRepository;

    @Override
    public String edit(@Valid AstPackOprParam param) {
        return this.doOpr(param, () -> astPackManager.add(param));
    }

    @Override
    public BasePage<AstPackListVO> getList(@Valid AstPackQryParam param) {
        return this.doQry(param, () -> {
            AstPackPagePage page = astPackRepository.getList(param);
            BasePage<AstPackListVO> result = new BasePage<AstPackListVO>();
            result.setCurrPageNo(page.getCurrPageNo());
            result.setTotal(page.getTotal());
            result.setLimit(page.getLimit());
            result.setDatas(AstPackListVOConvert.convert2VOList(page.getDatas()));
            return result;
        });
    }

}
