package com.abssqr.plat.biz.api.astPool;

import com.abssqr.plat.biz.support.ServiceSupport;
import com.abssqr.plat.common.dal.mysql.auto.paging.AstPoolPage;
import com.abssqr.plat.common.facade.enums.AstTypeEnum;
import com.abssqr.plat.common.facade.param.astPool.AstPoolOprParam;
import com.abssqr.plat.common.facade.param.astPool.AstPoolPageQryParam;
import com.abssqr.plat.common.facade.result.BasePage;
import com.abssqr.plat.common.facade.result.astPool.AstPoolVO;
import com.abssqr.plat.common.facade.service.AstPoolService;
import com.abssqr.plat.common.model.convertor.AstPoolConvert;
import com.abssqr.plat.common.model.domain.ast.AstPoolEntity;
import com.abssqr.plat.common.model.repo.astPool.AstPoolRepository;
import com.general.system.common.util.VarChecker;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class AstPoolServiceImpl extends ServiceSupport implements AstPoolService{

    @Autowired
    AstPoolRepository astPoolRepository;
    @Override
    public int add(AstPoolOprParam astPoolOprParam) {
        AstPoolEntity astPoolEntity=new AstPoolEntity();
        astPoolEntity.setAstTypeEnum(AstTypeEnum.getByCode(astPoolOprParam.getAstTypeCode()));
        astPoolEntity.setAstPoolNo(astPoolOprParam.getAstPoolNo());
        astPoolEntity.setAstPoolName(astPoolOprParam.getAstPoolName());
        VarChecker.checkArgument(astPoolRepository.checkAstPool(astPoolEntity),"资产池名称/资产池编号重复");
        return astPoolRepository.create(astPoolEntity);
    }

    @Override
    public BasePage<AstPoolVO> page(AstPoolPageQryParam astPoolPageQryParam) {
        BasePage<AstPoolVO> result=new BasePage();
        AstPoolPage page = astPoolRepository.getPage(astPoolPageQryParam);
        result.setDatas(AstPoolConvert.convert2VOs(page.getDatas()));
        result.setCurrPageNo(page.getCurrPageNo());
        result.setTotal(page.getTotal());
        return result;
    }

    @Override
    public AstPoolVO get(String astPoolNo) {
        AstPoolEntity astPoolEntity = astPoolRepository.getByAstPoolNo(astPoolNo);
        VarChecker.checkNotNull(astPoolEntity,"资产池不存在");
        return AstPoolConvert.convert2VO(astPoolEntity);
    }

}
